// ##########################################################################
// ####                                                                  ####
// ####                      RTP Audio Server Project                    ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### Demo Client                                                      ####
// ####                                                                  ####
// #### Version 1.00  --  February 16, 2001                              ####
// ####                                                                  ####
// #### Copyright (C) 1999  Thomas Dreibholz                             ####
// ####               2000  Universitt Bonn, Abt. IV                    ####
// ####               2001  EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################


import TransportInfo;


/**
  * This class is a simple demo client which should show how the multiple
  * stream bandwidth management works.
  *
  * @short   Demo Client
  * @author  Thomas Dreibholz (Dreibholz@bigfoot.com)
  * @version 1.0
  */
public class DemoClient
{
   // ###### Constructor ####################################################
   public DemoClient(long min, long max, long bandwidth) {
      MinBandwidth = min;
      MaxBandwidth = max;
      Bandwidth    = bandwidth;
   }

   // ###### Get transport info #############################################
   public void getTransportInfo(TransportInfo transportInfo) {
/*
      transportInfo.reset();
      transportInfo.MinFramesPerSecond        = (int)(MinBandwidth / 10000);
      transportInfo.MaxFramesPerSecond        = (int)(MaxBandwidth / 10000);
      transportInfo.WantedFramesPerSecond     = (int)(Bandwidth / 10000);

      transportInfo.MinBytesPerSecond[0]      = MinBandwidth;
      transportInfo.MaxBytesPerSecond[0]      = MaxBandwidth;
      transportInfo.WantedBytesPerSecond[0]   = Bandwidth;

      transportInfo.MinPacketsPerSecond[0]    = (int)(MinBandwidth / 1000);
      transportInfo.MaxPacketsPerSecond[0]    = (int)(MaxBandwidth / 1000);
      transportInfo.WantedPacketsPerSecond[0] = (int)(Bandwidth / 1000);

      transportInfo.CurrentSetting.QualityLayer[0].PacketsPerSecond = (int)(MinBandwidth / 1000);
      transportInfo.CurrentSetting.QualityLayer[0].PacketsPerSecond = (int)(MaxBandwidth / 1000);
      transportInfo.CurrentSetting.QualityLayer[0].PacketsPerSecond = (int)(Bandwidth / 1000);

      transportInfo.QualityLevels = 10;
      transportInfo.QualityLayers = 1;
      for(int i = 0;i < 10;i++) {
         transportInfo.QualityLevel[i].BytesPerSecondScale   = 65536;
         transportInfo.QualityLevel[i].PacketsPerSecondScale = 65536;
         transportInfo.QualityLevel[i].FramesPerSecondScale  = 65536;
         transportInfo.QualityLevel[i].FramesPerSecond       = 1;
         transportInfo.QualityLevel[i].QualityLayer[0].BytesPerSecond = (i + 1) * 100000;
         transportInfo.QualityLevel[i].QualityLayer[0].FramesPerSecond = (i + 1) * 10;
         transportInfo.QualityLevel[i].QualityLayer[0].PacketsPerSecond = (i + 1) * 1000;
         transportInfo.QualityLevel[i].QualityLayers = 1;
         if(i < 9)
            transportInfo.QualityLevel[i].LevelUp = i + 1;
         else
            transportInfo.QualityLevel[i].LevelUp = 255;
         if(i > 0)
            transportInfo.QualityLevel[i].LevelDown = i - 1;
         else
            transportInfo.QualityLevel[i].LevelDown = 255;
      }
*/


      // ====== Initialize wanted values ====================================
      transportInfo.MinBytesPerSecond[0]   = 2000;
      transportInfo.MaxBytesPerSecond[0]   = 2000;
      transportInfo.MinPacketsPerSecond[0] = -1;
      transportInfo.MaxPacketsPerSecond[0] = -1;
      transportInfo.WantedMaxLossRate[0]   = 0;

      transportInfo.MinBytesPerSecond[1]   = 5000;
      transportInfo.MaxBytesPerSecond[1]   = (20000000 / 8) - 2000;
      transportInfo.MinPacketsPerSecond[1] = -1;
      transportInfo.MaxPacketsPerSecond[1] = -1;
      transportInfo.WantedMaxLossRate[1]   = 25;

      for(int i = 2;i < TransportInfoLevel.MaxQualityLayers;i++) {
         transportInfo.MinBytesPerSecond[i]   = 0;
         transportInfo.MaxBytesPerSecond[i]   = 0;
         transportInfo.MinPacketsPerSecond[i] = 0;
         transportInfo.MaxPacketsPerSecond[i] = 0;
         transportInfo.WantedMaxLossRate[i]   = 0;
      }

      transportInfo.MinFramesPerSecond      = 1;
      transportInfo.MaxFramesPerSecond      = 30;
      transportInfo.WantedMaxTransferDelay  = 1000 * 16;
      transportInfo.StartFramesPerSecond    = 1;

      transportInfo.Flags         = TransportInfo.TIF_HasDynamic;
      transportInfo.QualityLevels = 1;
      transportInfo.QualityLayers = 2;
      

      // ====== Initialize level and layer ==================================
      transportInfo.QualityLevel[0].BytesPerSecondScale   = 65536;
      transportInfo.QualityLevel[0].PacketsPerSecondScale = 65536;
      transportInfo.QualityLevel[0].FramesPerSecondScale  = 65536;
      transportInfo.QualityLevel[0].MaxTransferDelay      = 16 * 1000;
      transportInfo.QualityLevel[0].Quality               = 255;
      transportInfo.QualityLevel[0].LevelUp               = 255;
      transportInfo.QualityLevel[0].LevelDown             = 255;
      transportInfo.QualityLevel[0].QualityLayers         = 2;

      transportInfo.QualityLevel[0].QualityLayer[0].BytesPerSecond   = 2000;
      transportInfo.QualityLevel[0].QualityLayer[0].PacketsPerSecond = -1;
      transportInfo.QualityLevel[0].QualityLayer[0].FrameSize        = 2000;
      transportInfo.QualityLevel[0].QualityLayer[0].MaxLossRate      = 0;
      transportInfo.QualityLevel[0].QualityLayer[0].Flags            = TransportInfoLayer.TILF_Dynamic;

      transportInfo.QualityLevel[0].QualityLayer[1].BytesPerSecond   = 10000;
      transportInfo.QualityLevel[0].QualityLayer[1].PacketsPerSecond = -1;
      transportInfo.QualityLevel[0].QualityLayer[1].FrameSize        = 10000;
      transportInfo.QualityLevel[0].QualityLayer[1].MaxLossRate      = 25;
      transportInfo.QualityLevel[0].QualityLayer[1].Flags            = TransportInfoLayer.TILF_Dynamic;


      // ====== Initialize current settings =================================
      transportInfo.CurrentSetting.BytesPerSecondScale   = 65536;
      transportInfo.CurrentSetting.PacketsPerSecondScale = 65536;
      transportInfo.CurrentSetting.FramesPerSecondScale  = 65536;
      transportInfo.CurrentSetting.FramesPerSecond = 1;
      transportInfo.CurrentSetting.MaxTransferDelay      = 16 * 1000;
      transportInfo.CurrentSetting.Quality               = 255;
      transportInfo.CurrentSetting.LevelUp               = 255;
      transportInfo.CurrentSetting.LevelDown             = 255;
      transportInfo.CurrentSetting.QualityLayers         = 2;

      transportInfo.CurrentSetting.QualityLayer[0].FrameSize   = 2000;
      transportInfo.CurrentSetting.QualityLayer[0].MaxLossRate = 0;
      transportInfo.CurrentSetting.QualityLayer[0].Flags       = TransportInfoLayer.TILF_Dynamic;

      transportInfo.CurrentSetting.QualityLayer[1].FrameSize   = 10000;
      transportInfo.CurrentSetting.QualityLayer[1].MaxLossRate = 25;
      transportInfo.CurrentSetting.QualityLayer[1].Flags       = TransportInfoLayer.TILF_Dynamic;



      transportInfo.CurrentSetting.QualityLayer[0].BytesPerSecond   = 0;
      transportInfo.CurrentSetting.QualityLayer[1].BytesPerSecond   = 0;
      transportInfo.CurrentSetting.QualityLayer[0].PacketsPerSecond = 0;
      transportInfo.CurrentSetting.QualityLayer[1].PacketsPerSecond = 0;


      long bps = 4000000 / 8;
      int  fps = 10;
      transportInfo.WantedBytesPerSecond[0]   = 2000 * fps;
      transportInfo.WantedBytesPerSecond[1]   = bps - 2000;
      transportInfo.WantedPacketsPerSecond[0] = -1;
      transportInfo.WantedPacketsPerSecond[1] = -1;
      transportInfo.WantedFramesPerSecond     = fps;

   }

   // ###### Set bandwidth ##################################################
   void setBandwidthLimit(long bandwidth) {
      Bandwidth = bandwidth;
   }


   // ###### Private data ###################################################
   private long MinBandwidth;
   private long MaxBandwidth;
   private long Bandwidth;
}
