// ##########################################################################
// ####                                                                  ####
// ####                      RTP Audio Server Project                    ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### Flow Info Implementation                                         ####
// ####                                                                  ####
// #### Version 1.00, February 17, 2000                                  ####
// ####                                                                  ####
// #### Copyright (C) 1999  Thomas Dreibholz                             ####
// ####               2000  Universitt Bonn, Abt. IV                    ####
// ####                     EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://titan.cs.uni-bonn.de/~dreibhol ####
// ####                                                                  ####
// ##########################################################################


#include "../system.h"
#include "../socketaddress.h"
#include "flowinfo.h"


namespace Coral {


// ###### Constructor #######################################################
FlowInfo::FlowInfo()
   : SocketAddress()
{
   FlowInfo = 0;
}


// ###### Constructor #######################################################
FlowInfo::FlowInfo(const SocketAddress* destination,
                   const card32         flowLabel,
                   const card8          trafficClass)
   : SocketAddress(*destination)
{
   FlowInfo = flowLabel | ((card32)trafficClass << 20);
}


// ###### Initialize ########################################################
void FlowInfo::init(sockaddr* address, const card32 length, const card32 flowInfo)
{
   SocketAddress::init(address,length);
   FlowInfo = flowInfo;
}


}
