#include "futureeventlist.h"

namespace Coral {

FutureEventList::FutureEventList()
  : Synchronizable()
{
}

void FutureEventList::push(FELElement elem)
{
  eventQueue.push(elem);
}

FELElement FutureEventList::pop()
{
  FELElement result = eventQueue.front();
  eventQueue.pop();
  return result;
}

bool FutureEventList::empty()
{
  return eventQueue.empty();
}

void FutureEventList::readInputFile(char* filename)
{
  ifstream infile(filename);

  char   eventName[255];
  double eventTime;
  int    argument;
  String s;

  FELElement elem;

  while(!infile.eof()) {

    // read time and push to queue
    infile >> eventTime;

    if(infile.eof()) break;

    elem.doubleArg = eventTime;
    eventQueue.push(elem);
    
    // read eventtype
    readOneWord(&infile, eventName);

    // cout << eventName << endl;
    
    if(s.stringCompare("new_session",eventName) == 0) {
      // push event type to queue
      elem.event = NEW_SESSION;
      eventQueue.push(elem);

      // read session number
      infile >> argument;
      elem.intArg = argument;           // session number
      eventQueue.push(elem);
    } else 
      
      if(s.stringCompare("close_session",eventName) == 0) {
	// push event type to queue
	elem.event = CLOSE_SESSION;
	eventQueue.push(elem);

	// read session number
	infile >> argument;
	elem.intArg = argument;
	eventQueue.push(elem);
      } else

	if(s.stringCompare("set_session_weight",eventName) == 0) {
	  // push event type to queue
	  elem.event = SET_SESSION_WEIGHT;
	  eventQueue.push(elem);

	  // read session number
	  infile >> argument;
	  elem.intArg = argument;
	  eventQueue.push(elem);

	  // read weight
	  infile >> argument;
	  elem.intArg = argument;
	  eventQueue.push(elem);

	} else
	  
	  if(s.stringCompare("new_stream",eventName) == 0) {
	    // push event type to queue
	    elem.event = NEW_STREAM;
	    eventQueue.push(elem);

	    // read session number
	    infile >> argument;
	    elem.intArg = argument;
	    eventQueue.push(elem);

	    // read flow number
	    infile >> argument;
	    elem.intArg = argument;
	    eventQueue.push(elem);

	    // read type
	    infile >> argument;
	    elem.intArg = argument;
	    eventQueue.push(elem);

	  } else

	    if(s.stringCompare("close_stream",eventName) == 0) {
	      // push event type to queue
	      elem.event = CLOSE_STREAM;
	      eventQueue.push(elem);

	      // read session number
	      infile >> argument;
	      elem.intArg = argument;           // session number
	      eventQueue.push(elem);

	      // read flow number
	      infile >> argument;
	      elem.intArg = argument;
	      eventQueue.push(elem);

	    } else {
	      cout << "unknown event in " << filename << endl;
	    }
  }
}

}
