#include "system.h"
#include "unixaddress.h"
#include "socket.h"


using namespace RTPAudio;

// #### Version 1.00  --  June 22, 2000                                  ####
int main(int argc, char** argv)
{
   UnixAddress s5("/tmp/test.sock");

   Socket sock(Socket::Unix,Socket::Datagram);
   if(sock.ready() == false) {
      cerr << "ERROR: socket!" << endl;
      exit(0);
   }

   // ====== Client-Modus ===================================================
   if(argc <= 1) {
      // Mit Server verbinden
      if(sock.connect(s5) == false) {
         cerr << "ERROR: connect!" << endl;
      }
      char* text = "Das ist ein Test!";
      sock.send(text,strlen(text)+1);
   }

   // ====== Server-Modus ===================================================
   else {   
      // Evtl. vorhandenes altes Socket-File lschen
      unlink(s5.getAddressString().getData());

      // Socket erstellen
      if(sock.bind(s5) == false) {
         cerr << "ERROR: bind!" << endl;
         exit(1);
      }

      // Alle ankommenden Texte ausgeben
      UnixAddress a;
      if(sock.getSocketAddress(a)) {
         cout << "Warte an " << a << endl;
         while(1) {
            char buffer[128];
            ssize_t bytes = sock.read((char*)&buffer,128);
            if(bytes > 0) {
               cout << "Nachricht: " << buffer << endl;
            }
         }
      }
   }
}
