// ##########################################################################
// ####                                                                  ####
// ####                      RTP Audio Server Project                    ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### NetLog File Header                                               ####
// ####                                                                  ####
// #### Version 1.00  --  February 16, 2001                              ####
// ####                                                                  ####
// #### Copyright (C) 1999  Thomas Dreibholz                             ####
// ####               2000  Universitt Bonn, Abt. IV                    ####
// ####               2001  EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################


#ifndef NETLOGFILEHEADER_H
#define NETLOGFILEHEADER_H


#include "system.h"


namespace Coral {


/**
  * This is the Header of a netlog file.
  *
  * @short   Network Log File Header
  * @author  Thomas Dreibholz (Dreibholz@bigfoot.com)
  * @version 1.0
  */
struct NetLogFileHeader
{
   char   ID[4];
   card16 Version;
   card16 EntrySize;
   card64 TimeStamp;
   card64 Interval;
   card32 Flags;
};


/**
  * ID of netlog file.
  */
#define NetLogFileHeaderID "TDNL"

/**
  * Current netlog version.
  */
#define NetLogFileHeaderVersion 0x0101

/**
  * Flags
  */
#define NLFH_Default         0
#define NLFH_ContainsStreams (1 << 0)


}


#endif
