package bonn.infoIV.v3d2.rtp;

import bonn.infoIV.v3d2.buffer.SyncBuffer3D;
import java.net.SocketException;
import java.net.InetAddress;
import java.net.UnknownHostException;

public class RTPSession
{
  protected DataChannel3D    DataChannel_    = null;
  protected ControlChannel3D ControlChannel_ = null;
  protected SyncBuffer3D     SyncBuffer3D_   = null;

  public RTPSession(InetAddress dest, int destPort, int dataPort) throws SocketException 
  {
    super();
    InetAddress localhost = null;
    try
    {
      localhost = InetAddress.getLocalHost();
    }
    catch(UnknownHostException e)
    {
      System.err.println("[Error]: reading the local Host: " +e.getMessage());
      System.exit(0);
    }
    SyncBuffer3D_   = new SyncBuffer3D();
    DataChannel_    = new DataChannel3D(dest, destPort, dataPort, SyncBuffer3D_);
    ControlChannel_ = new ControlChannel3D(dest, destPort+1, dataPort+1, DataChannel_);
  }


  public void startSession(Thread consumer)
  {
    DataChannel_.setConsumer(consumer);
    DataChannel_.start();
    ControlChannel_.start();
  }

  public SyncBuffer3D getBuffer() { return SyncBuffer3D_; }

  public Thread getProducer() { return DataChannel_; }

  public void sendApplicationMessage(int type, int value, int[] data)
  {
    switch(type)
    {
      case PayloadType.FRAMES_PER_SEC:
        ControlChannel_.MyControl_.updateFps(value);
        break;
      case PayloadType.BITS_PER_SEC:
        ControlChannel_.MyControl_.updateBps(value);
        break;
      case PayloadType.SPLITS_PERCENTAGE:
        ControlChannel_.MyControl_.updateSplitsPercentage(value);
        break;
      case PayloadType.START_TRANSFER:
        ControlChannel_.MyControl_.startTransfer(value, data);
        break;
      default:
        System.out.println("This Payloadtype is not supported");
    }
  }


  public void shutdown()
  {
    DataChannel_.shutdown();
    ControlChannel_.shutdown();
  }

}
