#include <byte_order/byte_order.hh>

void swap(char &src, char &dst)
{
  char tmp;

  tmp = src;
  src = dst;
  dst = tmp;
}

#ifndef BYTE_ORDER
#error "BYTE_ORDER undefined !"
#elif BYTE_ORDER == BIG_ENDIAN
unsigned short reverse(unsigned short value)
{
  return value;
}

unsigned int reverse(unsigned int value)
{
  return value;
}

float reverse(float value)
{
  return value;
}
#elif BYTE_ORDER == LITTLE_ENDIAN
unsigned short reverse(unsigned short value)
{
  char *byte_ptr = (char *) &value;

  for(unsigned int i = 0; i < sizeof(value) / 2; i++)
    swap(byte_ptr[i], byte_ptr[sizeof(value) - i - 1]);

  return value;
}

unsigned int reverse(unsigned int value)
{
  char *byte_ptr = (char *) &value;

  for(unsigned int i = 0; i < sizeof(value) / 2; i++)
    swap(byte_ptr[i], byte_ptr[sizeof(value) - i - 1]);

  return value;
}

float reverse(float value)
{
  char *byte_ptr = (char *) &value;

  for(unsigned int i = 0; i < sizeof(value) / 2; i++)
    swap(byte_ptr[i], byte_ptr[sizeof(value) - i - 1]);

  return value;
}
#else
#error "BYTE_ORDER unknown !"
#endif
