#include "system.h"
#include "audioquality.h"

using namespace RTPAudio;

// ###### Get conversion parameters #########################################
bool getConvParams(const cardinal in, const cardinal out, cardinal& a, cardinal& b)
// #### Version 1.00  --  June 22, 2000                                  ####
   for(cardinal y = 1;y < 20;y++) {
      cardinal rest = (y * in) % out;
      if(rest == 0) {
         b = y;
         a = (y * in) / out;
         return(true);
      }
   }
   return(false);
}

// ###### Calculate output frame size #######################################
cardinal calculateFrameSize(const AudioQuality& inputQuality,
                                                 const cardinal      inputFrameSize)
{
   return((inputQuality.getBytesPerSecond() * inputFrameSize) /
          AudioQuality::HighestQuality.getBytesPerSecond());
}


void main()
{

   AudioQuality q = AudioQuality::LowestQuality;
   for(int i = 0;i < 30;i++) {
      cardinal a = q.getBytesPerSecond();
      cardinal b = q.getBytesPerSecond() % 15;
      cardinal fs = q.getSamplingRate() / 15;
      cardinal fs2 = calculateFrameSize(q,2352*5);
      cout << i << "   " << q << "  a=" << a << " b=" << b << "  fs=" << fs << "  fs2=" << fs2 << endl;
      if(q == AudioQuality::HighestQuality)
         break;
      q++;
   }
exit(0);

   puts("------------------------");
   q = AudioQuality::HighestQuality;
   for(int i = 0;i < 30;i++) {
      cout << i << "   " << q << endl;
      if(q == AudioQuality::LowestQuality)
         break;
      q--;
   }
   

   int n = sizeof(AudioQuality::ValidRatesTable) / sizeof(card16);   
   for(int i = 0;i < n;i++) {
      for(int j = 0;j < n;j++) {
         cardinal a,b;
         bool ok = getConvParams(AudioQuality::ValidRatesTable[i],AudioQuality::ValidRatesTable[j],a,b);
         if(AudioQuality::ValidRatesTable[i] > AudioQuality::ValidRatesTable[j]) {
            printf("%5d -> %5d   a = %d  b = %d   diff=%d",AudioQuality::ValidRatesTable[i],AudioQuality::ValidRatesTable[j],a,b,a-b);
            if(ok == false) puts("ERROR!"); else puts("");
         }
      }
   }
}
